using UnityEngine;
using System;
using System.Collections.Generic;

namespace MvFF_lizXmiaSceneController {



    public class lizXmiaSceneController : MVRScript
    {

        private Atom _lizAtom;
        private Atom _miaAtom;
        private JSONStorable _overlays;
        private JSONStorable _timeline_elisabeth;
        private JSONStorable _timeline_mia;
        private JSONStorable _vammoan_elisabeth;
        private JSONStorable _vammoan_mia;
        private Atom _toggleRandSpeed;
        private Atom _sliderSpeed;
        private Atom _buttonAnimNext;
        private Atom _buttonAnimPrev;
        private Atom _buttonAnimPlay;
        private Atom _textAnimCurrent;
        private Atom _buttonSubAnimVaginal;
        private Atom _buttonSubAnimAnal;
        private Atom _buttonAnimOrgasm_Cum;
        private Atom _buttonAnimOrgasm_PullOut;
        private Atom _buttonMirrorToggle;
        private Atom _mirror;
        private DAZClothingItem _cockClothing;
        private float _cockClothingSpecIntensity = 0.2f;

        public JSONStorableBool _cockShouldGetWet;

        private string _currentSegment;
        private string _currentlyPlayingSegment;
        private int _currentSegmentIndex = 0;

        private List<SceneAnimation> _sceneAnimations;
        private SceneAnimation _currentSceneAnimation;
        private int _subAnimState = 0;
        private bool _randSpeedWasOn = false;

        private Atom _GetAtomById(string uid) {
            var atom = GetAtomById(uid);
            if (!atom) {
                SuperController.LogError($"Failed get '{uid}' Atom by ID");
                return null;
            }
            return atom;
        }

        public override void Init()
        {

            try {
                _lizAtom = _GetAtomById("Elisabeth");
                _miaAtom = _GetAtomById("Mia");
                _toggleRandSpeed = _GetAtomById("BasicUI/RandomSpeedToggle");
                _sliderSpeed = _GetAtomById("BasicUI/SpeedSlider");
                _buttonAnimNext = _GetAtomById("BasicUI/ButtonAnimNext");
                _buttonAnimPrev = _GetAtomById("BasicUI/ButtonAnimPrev");
                _buttonAnimPlay = _GetAtomById("BasicUI/ButtonPlay");
                _buttonAnimOrgasm_Cum = _GetAtomById("BasicUI/ButtonAnimOrgasm_Cum");
                _buttonAnimOrgasm_PullOut = _GetAtomById("BasicUI/ButtonAnimOrgasm_PullOut");
                // _cockShouldGetWet = _GetAtomById("CockShouldGetWet");
                _textAnimCurrent = _GetAtomById("BasicUI/TextAnimCurrent");

                _buttonSubAnimVaginal = _GetAtomById("BasicUI/ButtonSubAnimVaginal");
                _buttonSubAnimAnal = _GetAtomById("BasicUI/ButtonSubAnimAnal");

                _buttonMirrorToggle = _GetAtomById("ButtonMirrorToggle");
                _mirror = _GetAtomById("Glass");

                _overlays = _GetAtomById("Overlays").GetStorableByID("plugin#0_VAMOverlaysPlugin.VAMOverlays");

                _sceneAnimations = GetAnimations();
                _currentSegment = _sceneAnimations[0].AnimName;

                _timeline_elisabeth = GetTimelineForAtom(_lizAtom);
                _timeline_mia = GetTimelineForAtom(_miaAtom);

                _vammoan_elisabeth = GetMoanForAtom(_lizAtom);
                _vammoan_elisabeth.CallAction("Voice breathing");
                _vammoan_mia = GetMoanForAtom(_miaAtom);
                _vammoan_mia.CallAction("Voice breathing");

                _cockShouldGetWet = new JSONStorableBool("Cock Should Get Wet", false);
                RegisterBool(_cockShouldGetWet);

                _cockClothing = GetClothingForAtom(_lizAtom, "Genital skin extra 2");


                var textAtom = _textAnimCurrent.GetStorableByID("Text");
                var text = textAtom.GetStringJSONParam("text");
                text.val = _sceneAnimations[0].AnimName;

                UnityEngine.UI.Button button = _buttonAnimNext.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_NextAnimation);

                button = _buttonAnimPrev.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_PreviousAnimation);

                button = _buttonAnimPlay.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_PlayCurrentAnimation);

                button = _buttonSubAnimVaginal.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_SubAnimVaginal);

                button = _buttonSubAnimAnal.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_SubAnimAnal);

                button = _buttonAnimOrgasm_Cum.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_OrgasmCum);

                button = _buttonAnimOrgasm_PullOut.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_OrgasmPullOut);

                button = _buttonMirrorToggle.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Button>();
                button.onClick.AddListener(OnClick_MirrorToggle);

                PlayCurrentAnimation(); // should play intro to start

            }
            catch (Exception error) {
                SuperController.LogError($"Error: {error}");
            }


        }

        public void OnClick_MirrorToggle() {
            
            _mirror.ToggleOn();
        }

        public void OnClick_OrgasmCum() {

            var _anim = _currentSceneAnimation;
            var _animNameToCall = $"Play {_anim.orgasmCumAnimID}";

            if (_anim.AnimID != "Blowjob") {
                if (_subAnimState == 0) {
                    _animNameToCall = $"Play {_anim.orgasmCumAnimID}_vag";
                } else if (_subAnimState == 1) {
                    _animNameToCall = $"Play {_anim.orgasmCumAnimID}_anal";
                }
            }

            if (_anim.orgasmCumAnimID.Length > 0) {
                GetTimelineForAtom(_anim.secondAtom).CallAction($"Play {_anim.orgasmCumAnimID}");
                GetTimelineForAtom(_anim.mainAtom).CallAction(_animNameToCall);

                var randSpeedToggle = _toggleRandSpeed.childAtomContainer.GetComponentInChildren<UIToggleTrigger>().trigger;
                var floatParamRand = _toggleRandSpeed.GetStorableByID("plugin#0_MVRPlugin.FloatParamRandomizer");
                _randSpeedWasOn = randSpeedToggle.active;
                floatParamRand.enabled = false;
                _timeline_elisabeth.SetFloatParamValue("Speed", 1.5f);
                _timeline_mia.SetFloatParamValue("Speed", 1.5f);

                _timeline_elisabeth.CallAction($"Play org");
                _subAnimState = 2;
            }

        }

        public void OnClick_OrgasmPullOut() {

            var _anim = _currentSceneAnimation;
            if (_anim.orgasmPullOutAnimID.Length > 0) {
                _timeline_elisabeth.CallAction($"Play {_anim.orgasmPullOutAnimID}");
                _timeline_mia.CallAction($"Play {_anim.orgasmPullOutAnimID}");

                var randSpeedToggle = _toggleRandSpeed.childAtomContainer.GetComponentInChildren<UIToggleTrigger>().trigger;
                var floatParamRand = _toggleRandSpeed.GetStorableByID("plugin#0_MVRPlugin.FloatParamRandomizer");
                _randSpeedWasOn = randSpeedToggle.active;
                floatParamRand.enabled = false;
                _timeline_elisabeth.SetFloatParamValue("Speed", 1.5f);
                _timeline_mia.SetFloatParamValue("Speed", 1.5f);

                _timeline_elisabeth.CallAction($"Play org");
                _subAnimState = 2;

            }

        }

        public void OnClick_SubAnimVaginal() {
            var _anim = _currentSceneAnimation;

            if (_subAnimState == 1) {

                if (_anim.hasVaginalAnim) {
                    switch (_anim.mainAtom.name)
                    {
                        case "Elisabeth":
                            _timeline_elisabeth.CallAction($"Play {_anim.AnalToVagAnimName}");
                            break;
                        case "Mia":
                            _timeline_mia.CallAction($"Play {_anim.AnalToVagAnimName}");
                            break;
                    }

                }
            }

            if (_subAnimState == 2) {
                if (_anim.AnalToVagAnimName.Length > 0) {
                    GetTimelineForAtom(_anim.mainAtom).CallAction($"Play {_anim.AnalToVagAnimName}");
                    GetTimelineForAtom(_anim.secondAtom).CallAction($"Play {_anim.secondAtomLoopAnimID}");
                } else {
                    GetTimelineForAtom(_anim.mainAtom).CallAction($"Play {_anim.VaginalAnimName}");
                }
            }

            var randSpeedToggle = _toggleRandSpeed.childAtomContainer.GetComponentInChildren<UIToggleTrigger>().trigger;
            var floatParamRand = _toggleRandSpeed.GetStorableByID("plugin#0_MVRPlugin.FloatParamRandomizer");
            if (_randSpeedWasOn) {
                floatParamRand.enabled = true;
            }

            _subAnimState = 0;
        }

        public void OnClick_SubAnimAnal() {
            var _anim = _currentSceneAnimation;

            if (_subAnimState == 0) {

                if (_anim.hasAnalAnim) {
                    switch (_anim.mainAtom.name)
                    {
                        case "Elisabeth":
                            _timeline_elisabeth.CallAction($"Play {_anim.VagToAnalAnimName}");
                            break;
                        case "Mia":
                            _timeline_mia.CallAction($"Play {_anim.VagToAnalAnimName}");
                            break;
                    }
                }
            }

            if (_subAnimState == 2) {
                GetTimelineForAtom(_anim.mainAtom).CallAction($"Play {_anim.VagToAnalAnimName}");
                GetTimelineForAtom(_anim.secondAtom).CallAction($"Play {_anim.secondAtomLoopAnimID}");
            }

            var randSpeedToggle = _toggleRandSpeed.childAtomContainer.GetComponentInChildren<UIToggleTrigger>().trigger;
            var floatParamRand = _toggleRandSpeed.GetStorableByID("plugin#0_MVRPlugin.FloatParamRandomizer");
            if (_randSpeedWasOn) {
                floatParamRand.enabled = true;
            }

            _subAnimState = 1;

        }

        public void OnClick_NextAnimation() {
            _currentSegmentIndex = Math.Min(_sceneAnimations.Count, _currentSegmentIndex+1);
            _currentSegment = _sceneAnimations[_currentSegmentIndex].AnimName;

            var textAtom = _textAnimCurrent.GetStorableByID("Text");
            var text = textAtom.GetStringJSONParam("text");
            text.val = _currentSegment;
        }

        public void OnClick_PreviousAnimation() {
            _currentSegmentIndex = Math.Max(0, _currentSegmentIndex-1);
            _currentSegment = _sceneAnimations[_currentSegmentIndex].AnimName;

            var textAtom = _textAnimCurrent.GetStorableByID("Text");
            var text = textAtom.GetStringJSONParam("text");
            text.val = _currentSegment;
        }

        private bool _transition;
        private float _transEndTime;
        private readonly float _transDuration = 1.0f;

        public void OnClick_PlayCurrentAnimation() {

            var _anim = _sceneAnimations[_currentSegmentIndex];

            // if scene hasn't changed, don't bother fading, just unpause
            if (_anim.AnimID == _currentlyPlayingSegment) {

                // TODO: should be a null check on these
                GetTimelineForAtom(_anim.mainAtom).CallAction($"Play");
                GetTimelineForAtom(_anim.secondAtom).CallAction($"Play");

                GetMoanForAtom(_anim.mainAtom).CallAction(_anim.moanIntensity_mainAtom);
                GetMoanForAtom(_anim.secondAtom).CallAction(_anim.moanIntensity_secondAtom);
                
                return;
            }
 
            if (!_transition) {
                _transition = true;
                _transEndTime = Time.fixedTime + 2.0f;
                _overlays.CallAction("Start Fade Out");
            }

        }

        public void PlayCurrentAnimation() {
            var _anim = _sceneAnimations[_currentSegmentIndex];

            GetTimelineForAtom(_anim.mainAtom).CallAction($"Play Segment {_anim.AnimID}");
            GetTimelineForAtom(_anim.secondAtom).CallAction($"Play Segment {_anim.AnimID}");
            _currentlyPlayingSegment = _anim.AnimID;
            _currentSceneAnimation = _anim;

            GetMoanForAtom(_anim.mainAtom).CallAction(_anim.moanIntensity_mainAtom);
            GetMoanForAtom(_anim.secondAtom).CallAction(_anim.moanIntensity_secondAtom);

            _subAnimState = 0;

            SetupButtons();
        }

        private bool _sceneLoaded = false;

        public void Update() {


            if (!_sceneLoaded && !SuperController.singleton.isLoading) {
                _sceneLoaded = true;
                // something is setting this to true onload
                // hackfix override.
                _cockShouldGetWet.SetVal(false);
            }

            if (_transition && _transEndTime + _transDuration < Time.fixedTime) {
                _overlays.CallAction("Start Fade In");
                _transition = false;
            }

            if (_transition && _transEndTime < Time.fixedTime && (_sceneAnimations[_currentSegmentIndex].AnimID != _currentlyPlayingSegment)) {
                PlayCurrentAnimation();
            }

            _cockClothingSpecIntensity = UpdateCockWetness();
            SetSpecIntensityForClothing(_cockClothing, _cockClothingSpecIntensity);

        }

        private float UpdateCockWetness() {

            if (_cockShouldGetWet.val) {
                return Math.Min(_cockClothingSpecIntensity + 0.00015f, 2.0f);
            }

            return Math.Max(_cockClothingSpecIntensity - 0.00015f, 0.2f);
        }


        public JSONStorable GetTimelineForAtom(Atom atom) {

            foreach (string storableID in atom.GetStorableIDs()) {
                if (storableID.EndsWith("VamTimeline.AtomPlugin")) {
                    return atom.GetStorableByID(storableID);
                }
            }

            SuperController.LogMessage($"couldn't find timeline for atom: {atom.name}");
            return null;
        }

        public JSONStorable GetMoanForAtom(Atom atom) {

            foreach (string storableID in atom.GetStorableIDs()) {
                if (storableID.EndsWith("VAMMoanPlugin.VAMMoan")) {
                    return atom.GetStorableByID(storableID);
                }
            }

            SuperController.LogMessage($"couldn't find vammoan for atom: {atom.name}");
            return null;
        }

        public void SetSpecIntensityForClothing(DAZClothingItem clothing, float value) {

            foreach (var item in clothing.GetComponentsInChildren<DAZSkinWrapMaterialOptions>()) {
                item.SetFloatParamValue("Specular Intensity", value);
                return;
            }

            SuperController.LogMessage($"couldn't find Specular Intensity for clothing: {clothing.displayName}");
            return;
        }

        public DAZClothingItem GetClothingForAtom(Atom atom, string name) {

            foreach (var item in atom.GetComponentsInChildren<DAZClothingItem>()) {
                if (item.displayName.Contains(name)) {
                    return item;
                }
            }

            SuperController.LogMessage($"couldn't find clothing: {name} for atom: {atom.name}");
            return null;
        }

        private void SetupButtons() {

            var _vagText = _buttonSubAnimVaginal.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Text>();
            var _analText = _buttonSubAnimAnal.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Text>();
            var _cumText = _buttonAnimOrgasm_Cum.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Text>();
            var _pullText = _buttonAnimOrgasm_PullOut.childAtomContainer.GetComponentInChildren<UnityEngine.UI.Text>();

            switch (_currentSceneAnimation.AnimID) {

                case "Intro":
                    _vagText.text = "-";
                    _analText.text = "-";
                    _cumText.text = "-";
                    _pullText.text = "-";
                    break;
                case "Blowjob":
                    _vagText.text = "M";
                    _analText.text = "-";
                    _cumText.text = "-";
                    _pullText.text = "Facial";
                    break;
                case "AgainstMirrorBehind":
                    _vagText.text = "V";
                    _analText.text = "A";
                    _cumText.text = "Cum";
                    _pullText.text = "Pull Out";
                    break;
                case "AgainstWindowBehind":
                    _vagText.text = "V";
                    _analText.text = "A";
                    _cumText.text = "-";
                    _pullText.text = "Pull Out";
                    break;
                case "AgainstWindowFacing":
                    _vagText.text = "V";
                    _analText.text = "-";
                    _cumText.text = "Cum";
                    _pullText.text = "Pull Out";
                    break;
                case "CowgirlBed":
                    _vagText.text = "V";
                    _analText.text = "A";
                    _cumText.text = "Cum";
                    _pullText.text = "Pull Out";
                    break;
                case "CowgirlBentOver":
                    _vagText.text = "V";
                    _analText.text = "-";
                    _cumText.text = "Cum";
                    _pullText.text = "Pull Out";
                    break;
                case "CowgirlFacing":
                    _vagText.text = "V";
                    _analText.text = "A";
                    _cumText.text = "Cum";
                    _pullText.text = "Pull Out";
                    break;
                case "MissionaryBed":
                    _vagText.text = "V";
                    _analText.text = "A";
                    _cumText.text = "Cum";
                    _pullText.text = "Pull Out";
                    break;
                
            }



        }

        private List<SceneAnimation> GetAnimations() {
            var anims = new List<SceneAnimation>();

            var _newAnim = new SceneAnimation() {
                AnimID = "Intro",
                AnimName = "Intro",
                mainAtom = _lizAtom,
                secondAtom = _miaAtom,
                hasVaginalAnim = false,
                hasAnalAnim = false,
                VaginalAnimName = "",
                AnalAnimName = "",
                VagToAnalAnimName = "",
                AnalToVagAnimName = "",
                moanIntensity_mainAtom = "Voice breathing",
                moanIntensity_secondAtom = "Voice breathing",
            };
            anims.Add(_newAnim);

            _newAnim = new SceneAnimation() {
                AnimID = "Blowjob",
                AnimName = "Blowjob",
                mainAtom = _miaAtom,
                secondAtom = _lizAtom,
                hasVaginalAnim = true,
                hasAnalAnim = false,
                VaginalAnimName = "foreplay",
                AnalAnimName = "",
                VagToAnalAnimName = "",
                AnalToVagAnimName = "",
                moanIntensity_mainAtom = "Voice breathing",
                moanIntensity_secondAtom = "Voice breathing",
                orgasmCumAnimID = "bj_orgasm_in",
                orgasmPullOutAnimID = "bj_orgasm_out",
            };
            anims.Add(_newAnim);

            _newAnim = new SceneAnimation() {
                AnimID = "AgainstMirrorBehind",
                AnimName = "Against Mirror Behind",
                mainAtom = _lizAtom,
                secondAtom = _miaAtom,
                hasVaginalAnim = true,
                hasAnalAnim = true,
                VaginalAnimName = "Vaginal",
                AnalAnimName = "Anal",
                VagToAnalAnimName = "AMB_VagToAnal",
                AnalToVagAnimName = "AMB_AnalToVag",
                moanIntensity_mainAtom = "Voice intensity 1",
                moanIntensity_secondAtom = "Voice intensity 1",
                orgasmCumAnimID = "AMB_orgasm_in",
                orgasmPullOutAnimID = "AMB_orgasm_out",
            };
            anims.Add(_newAnim);
                
            _newAnim = new SceneAnimation() {
                AnimID = "AgainstWindowBehind",
                AnimName = "Against Window Behind",
                mainAtom = _lizAtom,
                secondAtom = _miaAtom,
                hasVaginalAnim = true,
                hasAnalAnim = true,
                VaginalAnimName = "Vaginal",
                AnalAnimName = "Anal",
                VagToAnalAnimName = "AWB_VagToAnal",
                AnalToVagAnimName = "AWB_AnalToVag",
                moanIntensity_mainAtom = "Voice intensity 1",
                moanIntensity_secondAtom = "Voice intensity 1",
                // orgasmCumAnimID = "AWB_orgasm_in",
                orgasmPullOutAnimID = "AWB_orgasm_out",
            };
            anims.Add(_newAnim);

            _newAnim = new SceneAnimation() {
                AnimID = "AgainstWindowFacing",
                AnimName = "Against Window Facing",
                mainAtom = _lizAtom,
                secondAtom = _miaAtom,
                hasVaginalAnim = true,
                hasAnalAnim = false,
                VaginalAnimName = "Anim 1",
                AnalAnimName = "",
                VagToAnalAnimName = "",
                AnalToVagAnimName = "",
                moanIntensity_mainAtom = "Voice intensity 1",
                moanIntensity_secondAtom = "Voice intensity 1",
                orgasmCumAnimID = "AWF_orgasm_in",
                orgasmPullOutAnimID = "AWF_orgasm_out",
            };
            anims.Add(_newAnim);

            _newAnim = new SceneAnimation() {
                AnimID = "CowgirlBed",
                AnimName = "Cowgirl Bed",
                mainAtom = _miaAtom,
                secondAtom = _lizAtom,
                hasVaginalAnim = true,
                hasAnalAnim = true,
                VaginalAnimName = "Vaginal",
                AnalAnimName = "Anal",
                VagToAnalAnimName = "CowG_VagToAnal",
                AnalToVagAnimName = "CowG_AnalToVag",
                moanIntensity_mainAtom = "Voice intensity 1",
                moanIntensity_secondAtom = "Voice intensity 1",
                orgasmCumAnimID = "CowG_orgasm_in",
                orgasmPullOutAnimID = "CowG_orgasm_out",
                secondAtomLoopAnimID = "loopCowgirl",
            };
            anims.Add(_newAnim);

            _newAnim = new SceneAnimation() {
                AnimID = "CowgirlBentOver",
                AnimName = "Cowgirl Bent Over",
                mainAtom = _miaAtom,
                secondAtom = _lizAtom,
                hasVaginalAnim = true,
                hasAnalAnim = false,
                VaginalAnimName = "Vaginal",
                AnalAnimName = "",
                VagToAnalAnimName = "",
                AnalToVagAnimName = "",
                moanIntensity_mainAtom = "Voice intensity 1",
                moanIntensity_secondAtom = "Voice intensity 1",
                orgasmCumAnimID = "CowGB_orgasm_in",
                orgasmPullOutAnimID = "CowGB_orgasm_out",
                secondAtomLoopAnimID = "loopCowgirlB",
            };
            anims.Add(_newAnim);

            _newAnim = new SceneAnimation() {
                AnimID = "CowgirlFacing",
                AnimName = "Cowgirl Facing",
                mainAtom = _miaAtom,
                secondAtom = _lizAtom,
                hasVaginalAnim = true,
                hasAnalAnim = true,
                VaginalAnimName = "Vaginal",
                AnalAnimName = "Anal",
                VagToAnalAnimName = "CowGF_VagToAnal",
                AnalToVagAnimName = "CowGF_AnalToVag",
                moanIntensity_mainAtom = "Voice intensity 1",
                moanIntensity_secondAtom = "Voice intensity 1",
                orgasmCumAnimID = "CowGF_orgasm_in",
                orgasmPullOutAnimID = "CowGF_orgasm_out",
                secondAtomLoopAnimID = "loopCowgirlF",
            };
            anims.Add(_newAnim);

            _newAnim = new SceneAnimation() {
                AnimID = "MissionaryBed",
                AnimName = "Missionary Bed",
                mainAtom = _lizAtom,
                secondAtom = _miaAtom,
                hasVaginalAnim = true,
                hasAnalAnim = true,
                VaginalAnimName = "Vaginal",
                AnalAnimName = "Anal",
                VagToAnalAnimName = "Miss_VagToAnal",
                AnalToVagAnimName = "Miss_AnalToVag",
                moanIntensity_mainAtom = "Voice intensity 1",
                moanIntensity_secondAtom = "Voice intensity 1",
                orgasmCumAnimID = "Miss_orgasm_in",
                orgasmPullOutAnimID = "Miss_orgasm_out",
            };
            anims.Add(_newAnim);

            return anims;
        }
    }

}

